#include <stdio.h>
extern unsigned short fast_crc16(unsigned short sum, 
                                 unsigned char *p, 
                                 unsigned long len);

extern unsigned long fast_crc32(unsigned long sum, 
                                 unsigned char *p, 
                                 unsigned long len);
 
extern unsigned short __checksum;
extern unsigned char crc_start;
extern unsigned char crc_end;
extern unsigned char crc_start2;
extern unsigned char crc_end2range;
 
void main(void)
{
     unsigned short sum=0;
 
     sum=fast_crc16(sum, (unsigned char *)&crc_start, 
                   (unsigned long)&crc_end - (unsigned long)&crc_start);
     sum=fast_crc16(sum, (unsigned char *)&crc_start2, 
                         (unsigned long)&crc_end2range);
 
     if(sum!=__checksum)
          printf("***Checksum failed: %hx instead of %hx!***\n",sum, __checksum);
     else
          printf("***Checksum is correct!***\n");
}

